diff --git a/python/rsa/tests/test_strings.py b/python/rsa/tests/test_strings.py
index 4af06291d4..2762dd3d9f 100644
--- a/python/rsa/tests/test_strings.py
+++ b/python/rsa/tests/test_strings.py
@@ -1,12 +1,12 @@
 '''Tests string operations.'''
 
-from __future__ import absolute_import
 
+from __future__ import print_function
 import unittest2
 
 import rsa
 
-from constants import unicode_string
+from .constants import unicode_string
 
 class StringTest(unittest2.TestCase):
 
@@ -16,13 +16,13 @@ class StringTest(unittest2.TestCase):
     def test_enc_dec(self):
 
         message = unicode_string.encode('utf-8')
-        print("\tMessage:   %s" % message)
+        print(("\tMessage:   %s" % message))
 
         encrypted = rsa.encrypt(message, self.pub)
-        print("\tEncrypted: %s" % encrypted)
+        print(("\tEncrypted: %s" % encrypted))
 
         decrypted = rsa.decrypt(encrypted, self.priv)
-        print("\tDecrypted: %s" % decrypted)
+        print(("\tDecrypted: %s" % decrypted))
 
         self.assertEqual(message, decrypted)
 
diff --git a/python/rsa/tests/test_transform.py b/python/rsa/tests/test_transform.py
index ffd9ec892a..392e824774 100644
--- a/python/rsa/tests/test_transform.py
+++ b/python/rsa/tests/test_transform.py
@@ -1,6 +1,3 @@
-# -*- coding: utf-8 -*-
-
-
 import unittest2
 from rsa._compat import b
 from rsa.transform import int2bytes, bytes2int, _int2bytes
diff --git a/python/slugid/setup.py b/python/slugid/setup.py
index d7c8b328bd..229849952b 100644
--- a/python/slugid/setup.py
+++ b/python/slugid/setup.py
@@ -14,7 +14,7 @@ packages = [
 ]
 
 version = ''
-with open('slugid/__init__.py', 'r') as fd:
+with open('slugid/__init__.py') as fd:
     version = re.search(r'^__version__\s*=\s*[\'"]([^\'"]*)[\'"]',
                         fd.read(), re.MULTILINE).group(1)
 
diff --git a/python/slugid/slugid/__init__.py b/python/slugid/slugid/__init__.py
index ca7de07e24..4d5b75b906 100644
--- a/python/slugid/slugid/__init__.py
+++ b/python/slugid/slugid/__init__.py
@@ -1,5 +1,3 @@
-# -*- coding: utf-8 -*-
-
 #    **************
 #    * Slugid API *
 #    **************
diff --git a/python/virtualenv/bin/rebuild-script.py b/python/virtualenv/bin/rebuild-script.py
index a816af3eb7..81b654ec79 100755
--- a/python/virtualenv/bin/rebuild-script.py
+++ b/python/virtualenv/bin/rebuild-script.py
@@ -2,7 +2,6 @@
 """
 Helper script to rebuild virtualenv.py from virtualenv_support
 """
-from __future__ import print_function
 
 import os
 import re
diff --git a/python/virtualenv/docs/conf.py b/python/virtualenv/docs/conf.py
index 9332aa1bc7..33920cf0d3 100644
--- a/python/virtualenv/docs/conf.py
+++ b/python/virtualenv/docs/conf.py
@@ -1,4 +1,3 @@
-# -*- coding: utf-8 -*-
 #
 # Paste documentation build configuration file, created by
 # sphinx-quickstart on Tue Apr 22 22:08:49 2008.
diff --git a/python/virtualenv/setup.py b/python/virtualenv/setup.py
index ee03bc5313..9d738d6b62 100644
--- a/python/virtualenv/setup.py
+++ b/python/virtualenv/setup.py
@@ -1,3 +1,4 @@
+from __future__ import print_function
 import os
 import re
 import shutil
diff --git a/python/virtualenv/site.py b/python/virtualenv/site.py
index bf23c19204..75a16b47a1 100644
--- a/python/virtualenv/site.py
+++ b/python/virtualenv/site.py
@@ -63,12 +63,13 @@ ImportError exception, it is silently ignored.
 
 """
 
+from __future__ import print_function
 import sys
 import os
 import platform
 
 try:
-    import __builtin__ as builtins
+    import builtins as builtins
 except ImportError:
     import builtins
 try:
@@ -139,7 +140,7 @@ def addbuilddir():
     """Append ./build/lib.<platform> in case we're running in the build dir
     (especially for Guido :-)"""
     from distutils.util import get_platform
-    s = "build/lib.%s-%.3s" % (get_platform(), sys.version)
+    s = "build/lib.{}-{:.3}".format(get_platform(), sys.version)
     if hasattr(sys, 'gettotalrefcount'):
         s += '-pydebug'
     s = os.path.join(os.path.dirname(sys.path[-1]), s)
@@ -167,8 +168,8 @@ def addpackage(sitedir, name, known_paths):
         reset = 0
     fullname = os.path.join(sitedir, name)
     try:
-        f = open(fullname, "rU")
-    except IOError:
+        f = open(fullname)
+    except OSError:
         return
     try:
         for line in f:
@@ -201,7 +202,7 @@ def addsitedir(sitedir, known_paths=None):
         sys.path.append(sitedir)        # Add path component
     try:
         names = os.listdir(sitedir)
-    except os.error:
+    except OSError:
         return
     names.sort()
     for name in names:
@@ -393,11 +394,11 @@ def setquit():
     else:
         eof = 'Ctrl-D (i.e. EOF)'
 
-    class Quitter(object):
+    class Quitter:
         def __init__(self, name):
             self.name = name
         def __repr__(self):
-            return 'Use %s() or %s to exit' % (self.name, eof)
+            return 'Use {}() or {} to exit'.format(self.name, eof)
         def __call__(self, code=None):
             # Shells like IDLE catch the SystemExit, but listen when their
             # stdin wrapper is closed.
@@ -410,7 +411,7 @@ def setquit():
     builtins.exit = Quitter('exit')
 
 
-class _Printer(object):
+class _Printer:
     """interactive prompt objects for printing the license text, a list of
     contributors and the copyright notice."""
 
@@ -431,11 +432,11 @@ class _Printer(object):
             for filename in self.__files:
                 filename = os.path.join(dir, filename)
                 try:
-                    fp = open(filename, "rU")
+                    fp = open(filename)
                     data = fp.read()
                     fp.close()
                     break
-                except IOError:
+                except OSError:
                     pass
             if data:
                 break
@@ -458,7 +459,7 @@ class _Printer(object):
         while 1:
             try:
                 for i in range(lineno, lineno + self.MAXLINES):
-                    print(self.__lines[i])
+                    print((self.__lines[i]))
             except IndexError:
                 break
             else:
@@ -466,9 +467,9 @@ class _Printer(object):
                 key = None
                 while key is None:
                     try:
-                        key = raw_input(prompt)
-                    except NameError:
                         key = input(prompt)
+                    except NameError:
+                        key = eval(input(prompt))
                     if key not in ('', 'q'):
                         key = None
                 if key == 'q':
@@ -496,7 +497,7 @@ def setcopyright():
         [os.path.join(here, os.pardir), here, os.curdir])
 
 
-class _Helper(object):
+class _Helper:
     """Define the built-in 'help'.
     This is a wrapper around pydoc.help (with a twist).
 
@@ -727,16 +728,16 @@ def _script():
     if not args:
         print("sys.path = [")
         for dir in sys.path:
-            print("    %r," % (dir,))
+            print(("    {!r},".format(dir)))
         print("]")
         def exists(path):
             if os.path.isdir(path):
                 return "exists"
             else:
                 return "doesn't exist"
-        print("USER_BASE: %r (%s)" % (USER_BASE, exists(USER_BASE)))
-        print("USER_SITE: %r (%s)" % (USER_SITE, exists(USER_BASE)))
-        print("ENABLE_USER_SITE: %r" %  ENABLE_USER_SITE)
+        print(("USER_BASE: {!r} ({})".format(USER_BASE, exists(USER_BASE))))
+        print(("USER_SITE: {!r} ({})".format(USER_SITE, exists(USER_BASE))))
+        print(("ENABLE_USER_SITE: %r" %  ENABLE_USER_SITE))
         sys.exit(0)
 
     buffer = []
@@ -746,7 +747,7 @@ def _script():
         buffer.append(USER_SITE)
 
     if buffer:
-        print(os.pathsep.join(buffer))
+        print((os.pathsep.join(buffer)))
         if ENABLE_USER_SITE:
             sys.exit(0)
         elif ENABLE_USER_SITE is False:
@@ -757,7 +758,7 @@ def _script():
             sys.exit(3)
     else:
         import textwrap
-        print(textwrap.dedent(help % (sys.argv[0], os.pathsep)))
+        print((textwrap.dedent(help % (sys.argv[0], os.pathsep))))
         sys.exit(10)
 
 if __name__ == '__main__':
diff --git a/python/virtualenv/tests/test_virtualenv.py b/python/virtualenv/tests/test_virtualenv.py
index 756cde9368..57fecf005c 100644
--- a/python/virtualenv/tests/test_virtualenv.py
+++ b/python/virtualenv/tests/test_virtualenv.py
@@ -7,7 +7,7 @@ import tempfile
 import pytest
 import platform  # noqa
 
-from mock import patch, Mock
+from unittest.mock import patch, Mock
 
 
 def test_version():
@@ -110,7 +110,7 @@ def test_install_python_bin():
         else:
             py_exe_no_version = 'python'
             py_exe_version_major = 'python%s' % sys.version_info[0]
-            py_exe_version_major_minor = 'python%s.%s' % (
+            py_exe_version_major_minor = 'python{}.{}'.format(
                 sys.version_info[0], sys.version_info[1])
             required_executables = [ py_exe_no_version, py_exe_version_major,
                                      py_exe_version_major_minor ]
diff --git a/python/virtualenv/virtualenv.py b/python/virtualenv/virtualenv.py
index 60a42e4dcb..f67a642305 100755
--- a/python/virtualenv/virtualenv.py
+++ b/python/virtualenv/virtualenv.py
@@ -1,8 +1,10 @@
 #!/usr/bin/env python
 """Create a "virtual" Python installation"""
 
+from __future__ import print_function
 import os
 import sys
+import six
 
 # If we are running in a new interpreter to create a virtualenv,
 # we do NOT want paths from our existing location interfering with anything,
@@ -32,7 +34,7 @@ from distutils.util import strtobool
 from os.path import join
 
 try:
-    import ConfigParser
+    import six.moves.configparser
 except ImportError:
     import configparser as ConfigParser
 
@@ -40,16 +42,16 @@ __version__ = "15.0.1"
 virtualenv_version = __version__  # legacy
 
 if sys.version_info < (2, 6):
-    print('ERROR: %s' % sys.exc_info()[1])
+    print(('ERROR: %s' % sys.exc_info()[1]))
     print('ERROR: this script requires Python 2.6 or greater.')
     sys.exit(101)
 
 import platform
 
 try:
-    basestring
+    str
 except NameError:
-    basestring = str
+    str = str
 
 is_tauthon = platform.python_implementation() == "Tauthon"
 is_jython = sys.platform.startswith('java')
@@ -60,7 +62,7 @@ is_msys2 = (sys.platform == 'win32' and os.sep == '/')
 is_darwin = (sys.platform == 'darwin')
 abiflags = getattr(sys, 'abiflags', '')
 
-py_version = '%s%s.%s' % ("tauthon" if is_tauthon else "python",
+py_version = '{}{}.{}'.format("tauthon" if is_tauthon else "python",
                           sys.version_info[0], sys.version_info[1])
 
 user_dir = os.path.expanduser('~')
@@ -86,13 +88,13 @@ else:
     try:
         import winreg
     except ImportError:
-        import _winreg as winreg
+        import six.moves.winreg as winreg
 
     def get_installed_pythons():
         try:
             python_core = winreg.CreateKey(winreg.HKEY_LOCAL_MACHINE,
                                            "Software\\Python\\PythonCore")
-        except WindowsError:
+        except OSError:
             # No registered Python installations
             return {}
         i = 0
@@ -101,13 +103,13 @@ else:
             try:
                 versions.append(winreg.EnumKey(python_core, i))
                 i = i + 1
-            except WindowsError:
+            except OSError:
                 break
         exes = dict()
         for ver in versions:
             try:
                 path = winreg.QueryValue(python_core, "%s\\InstallPath" % ver)
-            except WindowsError:
+            except OSError:
                 continue
             exes[ver] = join(path, "python.exe")
 
@@ -171,7 +173,7 @@ if is_pypy:
     REQUIRED_MODULES.extend(['traceback', 'linecache'])
 
 
-class Logger(object):
+class Logger:
 
     """
     Logging object for use in command-line script.  Allows ranges of
@@ -433,7 +435,7 @@ class ConfigOptionParser(optparse.OptionParser):
     configuration files and environmental variables
     """
     def __init__(self, *args, **kwargs):
-        self.config = ConfigParser.RawConfigParser()
+        self.config = six.moves.configparser.RawConfigParser()
         self.files = self.get_config_files()
         self.config.read(self.files)
         optparse.OptionParser.__init__(self, *args, **kwargs)
@@ -479,7 +481,7 @@ class ConfigOptionParser(optparse.OptionParser):
                     val = option.convert_value(key, val)
                 except optparse.OptionValueError:
                     e = sys.exc_info()[1]
-                    print("An error occurred during configuration: %s" % e)
+                    print(("An error occurred during configuration: %s" % e))
                     sys.exit(3)
                 defaults[option.dest] = val
         return defaults
@@ -512,7 +514,7 @@ class ConfigOptionParser(optparse.OptionParser):
         defaults = self.update_defaults(self.defaults.copy())  # ours
         for option in self._get_all_options():
             default = defaults.get(option.dest)
-            if isinstance(default, basestring):
+            if isinstance(default, str):
                 opt_str = option.get_opt_string()
                 defaults[option.dest] = option.check_value(opt_str, default)
         return optparse.Values(defaults)
@@ -679,8 +681,8 @@ def main():
         parser.print_help()
         sys.exit(2)
     if len(args) > 1:
-        print('There must be only one argument: DEST_DIR (you gave %s)' % (
-            ' '.join(args)))
+        print(('There must be only one argument: DEST_DIR (you gave %s)' % (
+            ' '.join(args))))
         parser.print_help()
         sys.exit(2)
 
@@ -758,7 +760,7 @@ def call_subprocess(cmd, show_stdout=True,
     except Exception:
         e = sys.exc_info()[1]
         logger.fatal(
-            "Error %s while executing command %s" % (e, cmd_desc))
+            "Error {} while executing command {}".format(e, cmd_desc))
         raise
     all_output = []
     if stdout is not None:
@@ -831,7 +833,7 @@ def find_wheels(projects, search_dirs):
                 break
         else:
             # We're out of luck, so quit with a suitable error
-            logger.fatal('Cannot find a wheel for %s' % (project,))
+            logger.fatal('Cannot find a wheel for {}'.format(project))
 
     return wheels
 
@@ -846,8 +848,8 @@ def install_wheel(project_names, py_executable, search_dirs=None,
     # PIP_FIND_LINKS uses space as the path separator and thus cannot have paths
     # with spaces in them. Convert any of those to local file:// URL form.
     try:
-        from urlparse import urljoin
-        from urllib import pathname2url
+        from urllib.parse import urljoin
+        from urllib.request import pathname2url
     except ImportError:
         from urllib.parse import urljoin
         from urllib.request import pathname2url
@@ -974,12 +976,12 @@ def path_locations(home_dir):
             size = max(len(home_dir)+1, 256)
             buf = ctypes.create_unicode_buffer(size)
             try:
-                u = unicode
+                u = str
             except NameError:
                 u = str
             ret = GetShortPathName(u(home_dir), buf, size)
             if not ret:
-                print('Error: the path "%s" has a space in it' % home_dir)
+                print(('Error: the path "%s" has a space in it' % home_dir))
                 print('We could not determine the short pathname for it.')
                 print('Exiting.')
                 sys.exit(3)
@@ -1243,9 +1245,9 @@ def install_python(home_dir, lib_dir, inc_dir, bin_dir, site_packages, clear, sy
                 os.unlink(python_d_dest)
             # we need to copy the DLL to enforce that windows will load the correct one.
             # may not exist if we are cygwin.
-            py_executable_dll = 'python%s%s.dll' % (
+            py_executable_dll = 'python{}{}.dll'.format(
                 sys.version_info[0], sys.version_info[1])
-            py_executable_dll_d = 'python%s%s_d.dll' % (
+            py_executable_dll_d = 'python{}{}_d.dll'.format(
                 sys.version_info[0], sys.version_info[1])
             pythondll = os.path.join(os.path.dirname(sys.executable), py_executable_dll)
             pythondll_d = os.path.join(os.path.dirname(sys.executable), py_executable_dll_d)
@@ -1351,7 +1353,7 @@ def install_python(home_dir, lib_dir, inc_dir, bin_dir, site_packages, clear, sy
     if not is_win:
         # Ensure that 'python', 'pythonX' and 'pythonX.Y' all exist
         py_exe_version_major = 'python%s' % sys.version_info[0]
-        py_exe_version_major_minor = 'python%s.%s' % (
+        py_exe_version_major_minor = 'python{}.{}'.format(
             sys.version_info[0], sys.version_info[1])
         py_exe_no_version = 'python'
         required_symlinks = [ py_exe_no_version, py_exe_version_major,
@@ -1388,7 +1390,7 @@ def install_python(home_dir, lib_dir, inc_dir, bin_dir, site_packages, clear, sy
     except OSError:
         e = sys.exc_info()[1]
         if e.errno == errno.EACCES:
-            logger.fatal('ERROR: The executable %s could not be run: %s' % (py_executable, e))
+            logger.fatal('ERROR: The executable {} could not be run: {}'.format(py_executable, e))
             sys.exit(100)
         else:
             raise e
@@ -1529,7 +1531,7 @@ def fix_lib64(lib_dir, symlink=True):
         return
     # Check we have a lib64 library path
     if not [p for p in distutils.sysconfig.get_config_vars().values()
-            if isinstance(p, basestring) and 'lib64' in p]:
+            if isinstance(p, str) and 'lib64' in p]:
         return
 
     logger.debug('This system uses lib64; symlinking lib64 to lib')
@@ -1566,10 +1568,10 @@ def resolve_interpreter(exe):
                 exe = join(path, exe)
                 break
     if not os.path.exists(exe):
-        logger.fatal('The executable %s (from --python=%s) does not exist' % (exe, exe))
+        logger.fatal('The executable {} (from --python={}) does not exist'.format(exe, exe))
         raise SystemExit(3)
     if not is_executable(exe):
-        logger.fatal('The executable %s (from --python=%s) is not executable' % (exe, exe))
+        logger.fatal('The executable {} (from --python={}) is not executable'.format(exe, exe))
         raise SystemExit(3)
     return exe
 
@@ -1703,7 +1705,7 @@ def fixup_pth_file(filename):
         else:
             new_value = make_relative_path(filename, line)
             if line != new_value:
-                logger.debug('Rewriting path %s as %s (in %s)' % (line, new_value, filename))
+                logger.debug('Rewriting path {} as {} (in {})'.format(line, new_value, filename))
             lines.append(new_value)
     if lines == prev_lines:
         logger.info('No changes to .pth file %s' % filename)
@@ -1719,7 +1721,7 @@ def fixup_egg_link(filename):
         logger.debug('Link in %s already relative' % filename)
         return
     new_link = make_relative_path(filename, link)
-    logger.notify('Rewriting link %s in %s as %s' % (link, filename, new_link))
+    logger.notify('Rewriting link {} in {} as {}'.format(link, filename, new_link))
     with open(filename, 'w') as f:
         f.write(new_link)
 
@@ -2200,7 +2202,7 @@ LC_LOAD_DYLIB = 0xc
 maxint = majver == 3 and getattr(sys, 'maxsize') or getattr(sys, 'maxint')
 
 
-class fileview(object):
+class fileview:
     """
     A proxy for file-like objects that exposes a given view of a file.
     Modified from macholib.
@@ -2224,7 +2226,7 @@ class fileview(object):
 
     def _checkwindow(self, seekto, op):
         if not (self._start <= seekto <= self._end):
-            raise IOError("%s to offset %d is outside window [%d, %d]" % (
+            raise OSError("%s to offset %d is outside window [%d, %d]" % (
                 op, seekto, self._start, self._end))
 
     def seek(self, offset, whence=0):
@@ -2236,7 +2238,7 @@ class fileview(object):
         elif whence == os.SEEK_END:
             seekto += self._end
         else:
-            raise IOError("Invalid whence argument to seek: %r" % (whence,))
+            raise OSError("Invalid whence argument to seek: {!r}".format(whence))
         self._checkwindow(seekto, 'seek')
         self._fileobj.seek(seekto)
         self._pos = seekto - self._start
@@ -2300,7 +2302,7 @@ def mach_o_change(path, what, value):
                 # If the string is what is being replaced, overwrite it.
                 if load == what:
                     file.seek(where + name_offset, os.SEEK_SET)
-                    file.write(value.encode() + '\0'.encode())
+                    file.write(value.encode() + b'\0')
             # Seek to the next command
             file.seek(where + cmdsize, os.SEEK_SET)
 
diff --git a/python/virtualenv/virtualenv_embedded/distutils-init.py b/python/virtualenv/virtualenv_embedded/distutils-init.py
index 29fc1da459..fe392b712b 100644
--- a/python/virtualenv/virtualenv_embedded/distutils-init.py
+++ b/python/virtualenv/virtualenv_embedded/distutils-init.py
@@ -25,9 +25,9 @@ else:
 from distutils import dist, sysconfig
 
 try:
-    basestring
+    str
 except NameError:
-    basestring = str
+    str = str
 
 ## patch build_ext (distutils doesn't know how to get the libs directory
 ## path on windows - it hardcodes the paths around the patched sys.prefix)
@@ -38,7 +38,7 @@ if sys.platform == 'win32':
         def finalize_options (self):
             if self.library_dirs is None:
                 self.library_dirs = []
-            elif isinstance(self.library_dirs, basestring):
+            elif isinstance(self.library_dirs, str):
                 self.library_dirs = self.library_dirs.split(os.pathsep)
             
             self.library_dirs.insert(0, os.path.join(sys.real_prefix, "Libs"))
diff --git a/python/virtualenv/virtualenv_embedded/site.py b/python/virtualenv/virtualenv_embedded/site.py
index 7969769c36..abf7dce9ca 100644
--- a/python/virtualenv/virtualenv_embedded/site.py
+++ b/python/virtualenv/virtualenv_embedded/site.py
@@ -63,10 +63,11 @@ ImportError exception, it is silently ignored.
 
 """
 
+from __future__ import print_function
 import sys
 import os
 try:
-    import __builtin__ as builtins
+    import builtins as builtins
 except ImportError:
     import builtins
 try:
@@ -134,7 +135,7 @@ def addbuilddir():
     """Append ./build/lib.<platform> in case we're running in the build dir
     (especially for Guido :-)"""
     from distutils.util import get_platform
-    s = "build/lib.%s-%.3s" % (get_platform(), sys.version)
+    s = "build/lib.{}-{:.3}".format(get_platform(), sys.version)
     if hasattr(sys, 'gettotalrefcount'):
         s += '-pydebug'
     s = os.path.join(os.path.dirname(sys.path[-1]), s)
@@ -162,8 +163,8 @@ def addpackage(sitedir, name, known_paths):
         reset = 0
     fullname = os.path.join(sitedir, name)
     try:
-        f = open(fullname, "rU")
-    except IOError:
+        f = open(fullname)
+    except OSError:
         return
     try:
         for line in f:
@@ -196,7 +197,7 @@ def addsitedir(sitedir, known_paths=None):
         sys.path.append(sitedir)        # Add path component
     try:
         names = os.listdir(sitedir)
-    except os.error:
+    except OSError:
         return
     names.sort()
     for name in names:
@@ -388,11 +389,11 @@ def setquit():
     else:
         eof = 'Ctrl-D (i.e. EOF)'
 
-    class Quitter(object):
+    class Quitter:
         def __init__(self, name):
             self.name = name
         def __repr__(self):
-            return 'Use %s() or %s to exit' % (self.name, eof)
+            return 'Use {}() or {} to exit'.format(self.name, eof)
         def __call__(self, code=None):
             # Shells like IDLE catch the SystemExit, but listen when their
             # stdin wrapper is closed.
@@ -405,7 +406,7 @@ def setquit():
     builtins.exit = Quitter('exit')
 
 
-class _Printer(object):
+class _Printer:
     """interactive prompt objects for printing the license text, a list of
     contributors and the copyright notice."""
 
@@ -426,11 +427,11 @@ class _Printer(object):
             for filename in self.__files:
                 filename = os.path.join(dir, filename)
                 try:
-                    fp = open(filename, "rU")
+                    fp = open(filename)
                     data = fp.read()
                     fp.close()
                     break
-                except IOError:
+                except OSError:
                     pass
             if data:
                 break
@@ -453,7 +454,7 @@ class _Printer(object):
         while 1:
             try:
                 for i in range(lineno, lineno + self.MAXLINES):
-                    print(self.__lines[i])
+                    print((self.__lines[i]))
             except IndexError:
                 break
             else:
@@ -461,9 +462,9 @@ class _Printer(object):
                 key = None
                 while key is None:
                     try:
-                        key = raw_input(prompt)
-                    except NameError:
                         key = input(prompt)
+                    except NameError:
+                        key = eval(input(prompt))
                     if key not in ('', 'q'):
                         key = None
                 if key == 'q':
@@ -491,7 +492,7 @@ def setcopyright():
         [os.path.join(here, os.pardir), here, os.curdir])
 
 
-class _Helper(object):
+class _Helper:
     """Define the built-in 'help'.
     This is a wrapper around pydoc.help (with a twist).
 
@@ -721,16 +722,16 @@ def _script():
     if not args:
         print("sys.path = [")
         for dir in sys.path:
-            print("    %r," % (dir,))
+            print(("    {!r},".format(dir)))
         print("]")
         def exists(path):
             if os.path.isdir(path):
                 return "exists"
             else:
                 return "doesn't exist"
-        print("USER_BASE: %r (%s)" % (USER_BASE, exists(USER_BASE)))
-        print("USER_SITE: %r (%s)" % (USER_SITE, exists(USER_BASE)))
-        print("ENABLE_USER_SITE: %r" %  ENABLE_USER_SITE)
+        print(("USER_BASE: {!r} ({})".format(USER_BASE, exists(USER_BASE))))
+        print(("USER_SITE: {!r} ({})".format(USER_SITE, exists(USER_BASE))))
+        print(("ENABLE_USER_SITE: %r" %  ENABLE_USER_SITE))
         sys.exit(0)
 
     buffer = []
@@ -740,7 +741,7 @@ def _script():
         buffer.append(USER_SITE)
 
     if buffer:
-        print(os.pathsep.join(buffer))
+        print((os.pathsep.join(buffer)))
         if ENABLE_USER_SITE:
             sys.exit(0)
         elif ENABLE_USER_SITE is False:
@@ -751,7 +752,7 @@ def _script():
             sys.exit(3)
     else:
         import textwrap
-        print(textwrap.dedent(help % (sys.argv[0], os.pathsep)))
+        print((textwrap.dedent(help % (sys.argv[0], os.pathsep))))
         sys.exit(10)
 
 if __name__ == '__main__':
diff --git a/python/voluptuous/setup.py b/python/voluptuous/setup.py
index 2fc07251dd..70d6cc23f8 100644
--- a/python/voluptuous/setup.py
+++ b/python/voluptuous/setup.py
@@ -1,3 +1,4 @@
+from __future__ import print_function
 try:
     from setuptools import setup
 except ImportError:
